<?php

defined('JPATH_PLATFORM') or die;

use LMS\Libraries;

JFormHelper::loadFieldClass('list');

class JFormFieldLanguage extends JFormFieldList
{	
	protected $type = 'Language';
	
	protected function getOptions()
	{
		$options = array();
		
		Libraries\ServiceLocator::load('lib.form.fields');		
		$rep	= Libraries\ServiceLocator::get('language_rep');		
		$items = $rep->find('language.id, language.name', array('language.published = 1'));
				
		foreach($items AS $item) {		
			$options[] = JHtml::_(
				'select.option', $item->name,
				$item->name, 'value', 'text',
				false
			);
		}	
		
		return $options;
	}
}
