<?php
defined('_JEXEC') or die;

echo $this->widget('contentheader');
echo $this->widget('contenttoolbar');

$fieldPublishStart = $this->form->getField('publish_start');
$fieldPublishEnd = $this->form->getField('publish_end');
$fieldStartDate = $this->form->getField('start_date');
$fieldEndDate = $this->form->getField('end_date');
$fieldPublished = $this->form->getField('published');
$fieldPaid = $this->form->getField('paid');
$fieldId = $this->form->getField('id');

JLMS_HTML::_('jlms_html.calendar.calendarextjs',$fieldStartDate->value, $fieldEndDate->value);

ob_start();
?>
jQuery(function($) {
	submitSubscriptionForm = function(){
		var form = $('#subscriptionForm');
		
		if (document.formvalidator.isValid(form))
		{		
			$.ajax({
				url: form.attr('action'),
				method: 'POST',
				data: form.serializeArray(),
				success: function(data){
					$('tbody', '#tableSubscriptions').empty();
					$('tbody', '#tableSubscriptions').append($('tbody tr', data));
				}
			});
		}
	}
	
	$('#tableSubscriptions').on('click', '.jlms-delete-btn', function(e){			
		e.preventDefault();
		$.ajax({
			url: $(this).attr('href'),
			success: function(data){
				$('tbody', '#tableSubscriptions').empty();
				$('tbody', '#tableSubscriptions').append($('tbody tr', data));
			}
		});			
	});
<?php	
	if(!$fieldPaid->value) { ?>
		$('#paidcoursesubs').hide();		
<?php
	}
	
	if(!$fieldPublishStart->value) {?>	
		document.adminForm.startday.disabled = true;
		document.adminForm.startmonth.disabled = true;
		document.adminForm.startyear.disabled = true;
		
		$('#startyy').data('chosen').search_field_disabled();
		$('#startmm').data('chosen').search_field_disabled();
		$('#startdd').data('chosen').search_field_disabled();		
	<?php }	
	
	if(!$fieldPublishEnd->value) {
	?>
		document.adminForm.endday.disabled = true;
		document.adminForm.endmonth.disabled = true;
		document.adminForm.endyear.disabled = true;	

		$('#endyy').data('chosen').search_field_disabled();
		$('#endmm').data('chosen').search_field_disabled();
		$('#enddd').data('chosen').search_field_disabled();		
		
	<?php } ?>
	$('#courseform_paid').change(function(){		
		$('#paidcoursesubs').toggle();		
	})
});
<?php
$script = ob_get_contents();
ob_end_clean();

$this->addScriptDeclaration($script);
?>
<form action="<?php echo JRoute::_('index.php?option=com_joomla_lms&course_id='.$this->courseId); ?>" enctype="multipart/form-data" method="post" class="form-validate form-horizontal" name="adminForm" id="adminForm">	
	<fieldset>	
		<legend><?php echo \JText::_('_JLMS_PUBLISING_OPTIONS'); ?>:</legend>
		<div class="control-group">
			<div class="control-label">
				<?php echo $fieldPublished->label;?>
			</div>
			<div class="controls">
				<?php echo $fieldPublished->input;?>
			</div>
		</div>
		<div class="control-group">
			<div class="control-label">
				<?php echo $fieldStartDate->label;?>
			</div>
			<div class="controls">
				<table class="jlms_date_outer" cellpadding="0" cellspacing="0" border="0">
				<tr>
				<td valign="middle">
					<input type="checkbox" value="1"  class="jlms_date_picker_check" name="courseform[publish_start]" onclick="jlms_Change_start()"<?php echo $fieldPublishStart->value?' checked="checked"':'';?> />
				</td>
				<td valign="middle" style="vertical-align:middle ">					
					<?php echo \JLMS_HTML::_('calendar.calendar', $fieldStartDate->value, 'start', 'start'); ?>
				</td>
				</tr>
				</table>				
			</div>
		</div>
		<div class="control-group">
			<div class="control-label">
				<?php echo $fieldEndDate->label;?>
			</div>
			<div class="controls">
				<table class="jlms_date_outer" cellpadding="0" cellspacing="0" border="0">
				<tr>
				<td valign="middle">
					<input type="checkbox" value="1"  class="jlms_date_picker_check" name="courseform[publish_end]" onclick="jlms_Change_end()"<?php echo $fieldPublishEnd->value?' checked="checked"':'';?> />
				</td>
				<td valign="middle" style="vertical-align:middle ">					
					<?php echo \JLMS_HTML::_('calendar.calendar', $fieldEndDate->value, 'end', 'end'); ?>
				</td>
				</tr>
				</table>					
			</div>
		</div>
		<?php if($this->config->get('show_course_fee_property', 1) == 1){ ?>
		<div class="control-group">
			<div class="control-label">
				<?php echo $fieldPaid->label;?>
			</div>
			<div class="controls">
				<?php echo $fieldPaid->input;?>
			</div>
		</div>
		<?php } ?>
	</fieldset>	
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="redirect" value="<?php echo base64_encode($this->redirect); ?>" />
	<input type="hidden" name="courseform[id]" value="<?php echo $this->courseId; ?>" />
	<?php echo JHtml::_('form.token'); ?>	
</form>
<fieldset id="paidcoursesubs">	
	<legend><?php echo \JText::_('_JLMS_PAID_COURSE_SUBSCRIPTIONS'); ?>:</legend>
	<?php $this->viewSubscriptions->display() ?>
	<?php $this->viewSubscription->edit() ?>
</fieldset>
